## therion 5.4.3ds1

=== Makefile ===
# common therion objects
export OUTDIR = .
CMNOBJECTS = thdate.o extern/shpopen.o extern/dbfopen.o \
  thexception.o thbuffer.o thmbuffer.o thlogfile.o thtmpdir.o thlocale.o \
  thparse.o thcmdline.o thconfig.o thinput.o thchenc.o thdatabase.o \
  thdataobject.o thdatareader.o thsurvey.o thendsurvey.o thdata.o \
  thperson.o thtf.o thtfangle.o thtflength.o thtfpwf.o \
  thdataleg.o thobjectname.o thinfnan.o thlayout.o thlookup.o thcomment.o \
  thinit.o thdb1d.o thsvxctrl.o thdatastation.o thobjectid.o \
  thobjectsrc.o thgrade.o thlibrary.o thgeomag.o thbezier.o \
  thexport.o thexporter.o thselector.o extern/img.o \
  thexpmodel.o thdb2d00.o thscrapis.o thcs.o thcsdata.o thexptable.o \
  thdb2d.o thscrap.o thendscrap.o th2ddataobject.o thdb2dprj.o \
  thdb2dpt.o thdb2dlp.o thdb2dab.o thdb2dji.o thdb2dmi.o thdb2dcp.o \
  thdb2dxm.o thdb2dxs.o thscraplo.o thscraplp.o thscrapen.o \
  thpoint.o thline.o tharea.o thlegenddata.o thmpost.o thsymbolsets.o \
  thjoin.o thmap.o thexpmap.o thlayoutln.o thlayoutclr.o thexpsys.o thexpuni.o \
  thconvert.o thpdf.o thpdfdbg.o thpdfdata.o thtexfonts.o \
  thsymbolset.o thlang.o thmapstat.o thexpdb.o thpic.o thsketch.o thproj.o \
  extern/lxMath.o extern/lxFile.o thdb3d.o thsurface.o thimport.o thsvg.o thepsparse.o \
  thtrans.o thwarpp.o thwarppt.o thwarppme.o thwarp.o thexpshp.o thattr.o thtex.o \
  extern/poly2tri/common/shapes.o extern/poly2tri/sweep/advancing_front.o extern/poly2tri/sweep/sweep.o extern/poly2tri/sweep/cdt.o extern/poly2tri/sweep/sweep_context.o \
  therion.o extern/quickhull/QuickHull.o

CROSS =
EXT =

# Prefix to install to (override like so: make PREFIX=/usr)
PREFIX = /usr/local
# Directory to install config files in (override like so: make SYSCONFDIR=/etc)
SYSCONFDIR = $(PREFIX)/etc

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS =
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHLINUX
##CCPFLAGS = -DTHLINUX
##LDPFLAGS = -s
##export THPLATFORM = LINUX
##OUTDIR = $(abspath $(PWD)/../therion.bin)
##THXTHMKCMD = $(OUTDIR)/therion


# PLATFORM DEBIAN
CXX = c++
CC = gcc
POBJECTS =
LOCHEXE = loch/loch
CXXPFLAGS = -DTHLINUX
CCPFLAGS = -DTHLINUX
LDPFLAGS = -s
export THPLATFORM = LINUX
THXTHMKCMD = ./therion


# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = extern/getopt.o extern/getopt1.o therion.res extern/getline.o
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -static -s
##export THPLATFORM = WIN32
##OUTDIR = $(abspath $(PWD)/../therion.bin)
##THXTHMKCMD = $(OUTDIR)/therion

# PLATFORM WIN32CROSS
##CROSS = i686-w64-mingw32.static-
##EXT = .exe
##CXX = $(CROSS)c++
##export CC = $(CROSS)gcc
##export AR = $(CROSS)ar
##POBJECTS = extern/getopt.o extern/getopt1.o therion.res extern/getline.o
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -static -s
##export THPLATFORM = WIN32
##THXTHMKCMD = therion
##OUTDIR = $(abspath $(PWD)/../therion.bin)

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##LOCHEXE = loch/loch
##POBJECTS = extern/getopt.o extern/getopt1.o extern/getline.o
##CXXPFLAGS = -DTHMACOSX
##CCPFLAGS = -DTHMACOSX
##LDPFLAGS =
##export THPLATFORM = MACOSX
##THXTHMKCMD = ./therion

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(LDPFLAGS)

# BUILD OXYGEN
CCBFLAGS = -O2
CXXBFLAGS = -O2
LDBFLAGS = $(LDPFLAGS)

# BUILD RELEASE
##CCBFLAGS =
##CXXBFLAGS =
##LDBFLAGS = $(LDPFLAGS)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DTHDEBUG
##LDBFLAGS =

# BUILD ENDCONFIG

# proj4 settings
PROJ_LIBS = $(shell $(CROSS)pkg-config proj --libs)
CXXJFLAGS = -I$(shell $(CROSS)pkg-config proj --variable=includedir)

# compiler settings
CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS) $(CXXJFLAGS) -std=c++11
CCFLAGS = -DIMG_API_VERSION=1 -Wall $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(OUTDIR)/,$(POBJECTS)) $(addprefix $(OUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS = $(PROJ_LIBS)
LDFLAGS = $(LDBFLAGS)


$(OUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.cpp
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<

all: version outdirs $(OUTDIR)/therion doc xtherion/xtherion $(LOCHEXE)

outdirs:
	mkdir -p $(OUTDIR)/extern/poly2tri/sweep/
	mkdir -p $(OUTDIR)/extern/poly2tri/common/
	mkdir -p $(OUTDIR)/extern/quickhull
	mkdir -p $(OUTDIR)/loch
	mkdir -p $(OUTDIR)/xtherion
	mkdir -p $(OUTDIR)/thbook

version:
	python set_version.py


$(OUTDIR)/therion: version $(OBJECTS)
	$(CXX) -Wall -o $(OUTDIR)/therion$(EXT) $(OBJECTS) $(LDFLAGS) $(LIBS)
ifneq ($(THPLATFORM),WIN32)
	$(MAKE) library
	$(MAKE) $(OUTDIR)/thlibrary.o
	$(CXX) -Wall -o $(OUTDIR)/therion$(EXT) $(OBJECTS) $(LDFLAGS) $(LIBS)
endif


$(OUTDIR)/therion.res: therion.rc
	$(CROSS)windres -i therion.rc -J rc -o $(OUTDIR)/therion.res -O coff

init:
	./therion --print-init-file > therion.ini

install: all
	tclsh makeinstall.tcl $(THPLATFORM) $(PREFIX) $(SYSCONFDIR)

minor-release:
	perl makerelease.pl

archive: config-debian unixify
	perl makearchive2.pl

release: clean
	perl makearchive.pl

binary: all doc
	perl makebinary.pl $(THPLATFORM)

depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -MM $(CXXFLAGS) *.cxx >> Makefile
	perl makedepend2.pl

library:
	$(THXTHMKCMD) --print-library-src thlibrarydata.thcfg > thlibrarydata.log
	$(THXTHMKCMD) --print-xtherion-src > xtherion/therion.tcl
	perl makelibrary.pl thlibrarydata.log > thlibrarydata.tmp
	perl maketest.pl thlibrarydata.tmp
	perl makefile.pl mv thlibrarydata.tmp thlibrarydata.cxx

xtherion/xtherion: version xtherion/*.tcl
	$(MAKE) -C ./xtherion

loch/loch: version loch/*.h loch/*.cxx loch/*.c
	$(MAKE) -C ./loch

doc: $(OUTDIR)/thbook/thbook.pdf

thbook: version $(OUTDIR)/thbook/thbook.pdf

samples: $(OUTDIR)/samples.doc/index.tex

$(OUTDIR)/samples.doc/index.tex:
	$(MAKE) -C samples
	touch thbook/version.tex
	$(MAKE) -C thbook

$(OUTDIR)/thbook/thbook.pdf: thbook/*.tex
	$(MAKE) -C thbook

clean:
	perl makefile.pl rm -q thlibrarydata.cxx ./xtherion/therion.tcl
	perl makefile.pl rmdir -q samples.doc
	$(MAKE) -C ./samples clean
	$(MAKE) cleanrest

cleanrest:
	$(MAKE) -C ./xtherion clean
	$(MAKE) -C ./loch clean
	perl makefile.pl rm -q thmpost.cxx thtex.h thlangdata.h thchencdata.cxx thcsdata.h thmpost.h thcsdata.cxx thtex.cxx thsymbolsetlist.h thsymbolsets.cxx thsymbolsets.h thlangdata.cxx thchencdata.h
	perl makefile.pl rm -q therion ./xtherion/xtherion ./xtherion/xtherion.tcl therion.exe *~ *.log *.o thchencdata/*~ .xtherion.dat ./xtherion/ver.tcl thversion.h thbook/version.tex
	perl makefile.pl rm -q xtherion/*~ .xth_thconfig_xth xtherion/screendump thlang/*~
	perl makefile.pl rm -q extern/*.o extern/*~ extern/poly2tri/common/*.o extern/poly2tri/sweep/*.o samples/*~ samples/*.log
	perl makefile.pl rm -q symbols.html therion.res
	perl makefile.pl rm -q tri/*.o tri/*~
	perl makefile.pl rm -q tex/*~
	perl makefile.pl rm -q us.stackdump loch/us.stackdump samples/us.stackdump xtherion/us.stackdump
	perl makefile.pl rm -q mpost/*~ examples/*~ examples/therion.log
	perl makefile.pl rm -q core symbols.xhtml cave.kml
	perl makefile.pl rm -q data.3d data.svx data.pos data.pts data.err data.plt
	perl makefile.pl rm -q cave.3d cave.lox cave.thm cave.pdf cave.sql cave.xhtml therion.tcl cave_a.pdf cave_m.pdf cave.vrml cave.wrl cave.3dmf cave.svg cave.tlx
	perl makefile.pl rm -q ./thbook/*~ ./thbook/thbook.log ./thbook/thbook.pdf ./lib/*~ ./mpost/*~ ./tex/*~
	perl makefile.pl rmdir -q doc thTMPDIR samples.doc symbols cave.shp tests/.doc
	perl makefile.pl rmdir -q doc symbols cave.shp tests/.doc
	perl makefile.pl rmdir -q thTMPDIR samples/*/thTMPDIR samples/*/*/thTMPDIR

thmpost.h: mpost/*.mp
	$(MAKE) -C ./mpost

thmpost.cxx: mpost/*.mp
	$(MAKE) -C ./mpost

thlibrarydata.cxx:
	perl makefile.pl cp thlibrarydata.src thlibrarydata.cxx

thsymbolsetlist.h: thsymbolsetlist.pl mpost/thTrans.mp
	perl thsymbolsetlist.pl

thtex.h: tex/*.tex
	$(MAKE) -C ./tex

thtex.cxx: tex/*.tex
	$(MAKE) -C ./tex

thchencdata.h: thchencdata/*.TXT
	$(MAKE) -C ./thchencdata

thcsdata.h: thcsdata.tcl
	tclsh thcsdata.tcl

update:
	$(MAKE) -C ./thlang update

unixify: clean
	tclsh makeunixify.tcl

thlangdata.h: thlang/texts.txt
	$(MAKE) -C ./thlang

config-debug:
	perl makeconfig.pl BUILD DEBUG
	$(MAKE) -C ./loch config-debug

config-release:
	perl makeconfig.pl BUILD RELEASE
	$(MAKE) -C ./loch config-release

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN
	$(MAKE) -C ./loch config-oxygen

config-ozone:
	perl makeconfig.pl BUILD OZONE
	$(MAKE) -C ./loch config-ozone

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN
	$(MAKE) -C ./loch config-debian

config-linux:
	perl makeconfig.pl PLATFORM LINUX
	$(MAKE) -C ./loch config-linux

config-win32:
	perl makeconfig.pl PLATFORM WIN32
	$(MAKE) -C ./loch config-win32

config-win32cross:
	perl makeconfig.pl PLATFORM WIN32CROSS
	$(MAKE) -C ./loch config-win32cross

config-macosx:
	perl makeconfig.pl PLATFORM MACOSX
	$(MAKE) -C ./loch config-macosx

# external sources
$(OUTDIR)/extern/lxMath.o: loch/lxMath.h loch/lxMath.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxMath.o loch/lxMath.cxx

$(OUTDIR)/extern/lxFile.o: loch/lxFile.h loch/lxFile.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxFile.o loch/lxFile.cxx

extern/getopt.o: extern/getopt.c extern/getopt.h
extern/getopt1.o: extern/getopt1.c
extern/img.o: extern/img.c extern/img.h
extern/poly2tri/common/shapes.o: extern/poly2tri/common/shapes.cc extern/poly2tri/common/shapes.h
extern/poly2tri/sweep/advancing_front.o: extern/poly2tri/sweep/advancing_front.cc
extern/poly2tri/sweep/sweep.o: extern/poly2tri/sweep/sweep.cc
extern/poly2tri/sweep/cdt.o: extern/poly2tri/sweep/cdt.cc
extern/poly2tri/sweep/sweep_context.o: extern/poly2tri/sweep/sweep_context.cc

# DEPENDENCIES
$(OUTDIR)/th2ddataobject.o: th2ddataobject.cxx th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thlayoutclr.h thscraplo.h thlayoutln.h thscrapen.h thscraplp.h \
 thexception.h thsymbolset.h thsymbolsetlist.h
$(OUTDIR)/tharea.o: tharea.cxx tharea.h th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thlayoutclr.h thscraplo.h thlayoutln.h thscrapen.h thscraplp.h \
 thexception.h thexpmap.h thexport.h thlayout.h thsymbolset.h \
 thsymbolsetlist.h thlocale.h thlang.h thlangdata.h thline.h
$(OUTDIR)/thattr.o: thattr.cxx thattr.h thmbuffer.h thchenc.h thchencdata.h \
 thparse.h thbuffer.h extern/shapefil.h thexception.h therion.h
$(OUTDIR)/thbezier.o: thbezier.cxx thbezier.h
$(OUTDIR)/thbuffer.o: thbuffer.cxx thbuffer.h
$(OUTDIR)/thchenc.o: thchenc.cxx thchenc.h thchencdata.h thparse.h thbuffer.h \
 thmbuffer.h thchencdata.cxx therion.h thexception.h
$(OUTDIR)/thchencdata.o: thchencdata.cxx
$(OUTDIR)/thcmdline.o: thcmdline.cxx thcmdline.h therion.h thlogfile.h thbuffer.h \
 thconfig.h thmbuffer.h thinput.h thparse.h thexporter.h thexport.h \
 thobjectsrc.h thlayout.h thdataobject.h thdatabase.h thdb1d.h \
 thobjectid.h thinfnan.h thdataleg.h thobjectname.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \

=== loch/Makefile ===
OUTDIR ?= .
THPLATFORM ?= LINUX
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)/loch
else
LOUTDIR = .
endif



# common therion objects
CMNOBJECTS = \
  lxTR.o lxOGLFT.o lxSetup.o lxRender.o lxWX.o \
  lxImgIO.o lxLRUD.o lxFile.o lxSTree.o \
  lxData.o lxMath.o lxSView.o lxSScene.o \
  lxGUI.o lxGLC.o lxOptDlg.o lxAboutDlg.o lxPres.o \
  img.o

CROSS =
EXT =

VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
VTKV6 = $(shell tclsh ./getvtkver.tcl version6)
ifeq ($(VTKV6),1)
VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
else
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
endif
# VTKVERSION = 5.4
# VTKPATH = /usr/local/include/vtk-$(VTKVERSION)
# VTKLIBPATH = /usr/local/lib/vtk-$(VTKVERSION)
POSTMAKE =
STRIPFLAG = -s

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS = lxR2P.o
##ifeq ($(VTKV6),1)
##VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
##else
##VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
##endif
##CXXPFLAGS = -DLXLINUX -std=c++11 $(shell wx-config --cxxflags) -Wno-deprecated $(shell pkg-config freetype2 --cflags) -I$(VTKPATH)
##CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
##LXLIBDIR = linux
##PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
##LXPLATFORM = LINUX

# PLATFORM DEBIAN
CXX = c++
CC = gcc
POBJECTS = lxR2P.o
ifeq ($(VTKV6),1)
VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
else
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
endif
CXXPFLAGS = -DLXLINUX -std=c++11 $(shell wx-config --cxxflags) -Wno-deprecated $(shell pkg-config freetype2 --cflags) -I$(VTKPATH)
CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
LXLIBDIR = linux
PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
LXPLATFORM = LINUX

# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = loch.res lxR2D.o getline.o
##CXXPFLAGS = -W -Wall -DLXWIN32 $(shell wx-config --static --cxxflags) $(shell pkg-config freetype2 --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell wx-config --static --cflags)
##LXLIBDIR = mingw
##PLIBS = $(shell pkg-config freetype2 --libs) $(shell wx-config --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -static -s

# PLATFORM WIN32CROSS
##CROSS= i686-w64-mingw32.static-
##EXT = .exe
##VTKVERSION = 8.0
##VTKPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/include/vtk-8.0
##VTKLIBPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/lib
##VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) \
##  -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) \
##  -lvtkIOLegacy-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkIOCore-$(VTKVERSION) \
##  -lvtkCommonTransforms-$(VTKVERSION) -lvtkCommonMisc-$(VTKVERSION) -lvtkCommonMath-$(VTKVERSION) -lvtkCommonSystem-$(VTKVERSION) \
##  -lvtksys-$(VTKVERSION) -lvtkfreetype-$(VTKVERSION) -lvtkpng-$(VTKVERSION) -lvtkjpeg-$(VTKVERSION) -lvtkzlib-$(VTKVERSION)
##CXX = $(CROSS)c++
##CC = $(CROSS)gcc
##POBJECTS = loch.res lxR2D.o getline.o
##CXXPFLAGS = -W -Wall -std=gnu++11 -DLXWIN32 $(shell $(CROSS)wx-config --static --cxxflags) $(shell $(CROSS)pkg-config freetype2 --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell $(CROSS)wx-config --static --cflags)
##LXLIBDIR =
##PLIBS = $(shell $(CROSS)pkg-config freetype2 --libs) $(shell $(CROSS)wx-config --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -static -s

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##POBJECTS =
##CXXPFLAGS = -W -Wall -std=c++11 -DLXMACOSX $(shell wx-config --cxxflags) $(shell pkg-config freetype2 --cflags) -I$(VTKPATH) -Wno-deprecated -I/usr/X11R6/include -I/usr/X11R6/include/freetype2
##CCPFLAGS = -W -Wall -DLXMACOSX $(shell wx-config --cflags) -I/usr/X11R6/include
##LXLIBDIR =
##PLIBS = -lz -L/usr/X11R6/lib $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LOCHAPPBINDIR := $(shell mkdir -p ./loch.app/Contents/MacOS)
##POSTMAKE = cp -f ./loch ./loch.app/Contents/MacOS/loch
##STRIPFLAG =

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(STRIPFLAG)

# BUILD OXYGEN
CCBFLAGS = -O2
CXXBFLAGS = -O2
LDBFLAGS = $(STRIPFLAG)

# BUILD RELEASE
##CCBFLAGS =
##CXXBFLAGS =
##LDBFLAGS = $(STRIPFLAG)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DLXDEBUG
##LDBFLAGS =

# BUILD ENDCONFIG


# compiler settings
CXXFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CXXPFLAGS) $(CXXBFLAGS)
CCFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(LOUTDIR)/,$(POBJECTS)) $(addprefix $(LOUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS = $(PLIBS)
LDFLAGS = $(LDBFLAGS)


$(LOUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<


all: $(LOUTDIR)/loch hlp

hlp:
	$(MAKE) -C ./help

$(LOUTDIR)/loch: $(OBJECTS)
	$(CXX) -o $(LOUTDIR)/loch$(EXT) -Wall $(OBJECTS) $(LIBS) $(LDFLAGS)
	$(POSTMAKE)

$(LOUTDIR)/loch.res: loch.rc loch.ico
	$(CROSS)windres -i loch.rc $(shell $(CROSS)wx-config --cflags | tr ' ' '\n' | grep "^-I" | tr '\n' ' ') -J rc -o $(LOUTDIR)/loch.res -O coff

graphs:
	dot -Tps graph-vispipe.dot -o graph-vispipe.ps


depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -DLXDEPCHECK -DLOCH -D'wxCHECK_VERSION(X,Y,Z)=1' -MM *.cxx >> Makefile
	$(CC) -DLXDEPCHECK -DLOCH -MM *.c >> Makefile
	perl makedepend2.pl


config-debug:
	perl makeconfig.pl BUILD DEBUG

test-release:
	zip -9 loch.zip loch.exe test.th test.jpg thconfig

config-release:
	perl makeconfig.pl BUILD RELEASE

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN

config-ozone:
	perl makeconfig.pl BUILD OZONE

config-linux:
	perl makeconfig.pl PLATFORM LINUX

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN

config-win32:
	perl makeconfig.pl PLATFORM WIN32

config-win32cross:
	perl makeconfig.pl PLATFORM WIN32CROSS

config-macosx:
	perl makeconfig.pl PLATFORM MACOSX

clean:
	perl makefile.pl rm -q *~
	perl makefile.pl rm -q help/*/*~
	perl makefile.pl rm -q loch.exe
	perl makefile.pl rm -q loch
	perl makefile.pl rm -q loch.app/Contents/MacOS/loch
	perl makefile.pl rm -q *.o
	perl makefile.pl rm -q *.log
	perl makefile.pl rm -q core
	perl makefile.pl rmdir -q .xvpics
	perl makefile.pl rm -q *.bmp
	perl makefile.pl rm -q *.ppm
	perl makefile.pl rm -q *.zip
	perl makefile.pl rm -q *.pdf
	perl makefile.pl rm -q *.png
#	$(MAKE) -C help clean



# DEPENDENCIES
$(LOUTDIR)/lxAboutDlg.o: lxAboutDlg.cxx lxWX.h icons/about.xpm ../thversion.h
$(LOUTDIR)/lxData.o: lxData.cxx lxData.h lxMath.h lxImgIO.h lxFile.h lxLRUD.h
$(LOUTDIR)/lxFile.o: lxFile.cxx lxFile.h lxMath.h img.h ../extern/img.h
$(LOUTDIR)/lxGLC.o: lxGLC.cxx lxGLC.h lxMath.h lxGUI.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxSView.h lxWX.h lxFNT6x13_bdf.h lxFNT10x20_bdf.h \
 lxFNTFreeSans_ttf.h lxRender.h lxTR.h
$(LOUTDIR)/lxGUI.o: lxGUI.cxx lxGUI.h lxGLC.h lxMath.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxRender.h lxOptDlg.h lxAboutDlg.h lxSView.h lxWX.h lxSScene.h \
 lxSTree.h lxPres.h icons/open.xpm icons/render.xpm icons/reload.xpm \
 icons/stereo.xpm icons/rotation.xpm icons/lockrot.xpm icons/fit.xpm \
 icons/home.xpm icons/rendersetup.xpm icons/plan.xpm icons/profile.xpm \
 icons/fullscreen.xpm icons/orto.xpm icons/camera.xpm icons/scene.xpm \
 icons/viscline.xpm icons/vissurface.xpm icons/visbbox.xpm \
 icons/viswalls.xpm icons/visinds.xpm icons/visentrance.xpm \
 icons/visfix.xpm icons/visstation.xpm icons/vislabel.xpm loch.xpm
$(LOUTDIR)/lxImgIO.o: lxImgIO.cxx lxImgIO.h
$(LOUTDIR)/lxLRUD.o: lxLRUD.cxx lxLRUD.h lxMath.h
$(LOUTDIR)/lxMath.o: lxMath.cxx lxMath.h
$(LOUTDIR)/lxOGLFT.o: lxOGLFT.cxx lxOGLFT.h
$(LOUTDIR)/lxOptDlg.o: lxOptDlg.cxx lxWX.h lxGUI.h lxGLC.h lxMath.h
$(LOUTDIR)/lxPres.o: lxPres.cxx lxPres.h lxWX.h lxGUI.h lxGLC.h lxMath.h lxSetup.h \
 lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxRender.o: lxRender.cxx lxRender.h lxWX.h lxGLC.h lxMath.h lxGUI.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h lxTR.h
$(LOUTDIR)/lxSScene.o: lxSScene.cxx lxSScene.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSTree.o: lxSTree.cxx lxSTree.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSView.o: lxSView.cxx lxSView.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSetup.o: lxSetup.cxx lxSetup.h lxData.h lxMath.h lxImgIO.h lxFile.h
$(LOUTDIR)/lxWX.o: lxWX.cxx lxWX.h
$(LOUTDIR)/getline.o: getline.c
$(LOUTDIR)/img.o: img.c ../extern/img.c ../extern/img.h
$(LOUTDIR)/lxR2D.o: lxR2D.c lxR2D.h
$(LOUTDIR)/lxR2P.o: lxR2P.c lxR2P.h
$(LOUTDIR)/lxTR.o: lxTR.c lxTR.h

=== debian/changelog ===
therion (5.4.3ds1-6) unstable; urgency=medium

  * debian/patches/fix-epsg-esri-cs.patch: Fix coordinate system handling when
    more than one coordinate system is specified using an EPSG or ESRI code.
    (Closes: #930289)

 -- Olly Betts <olly@survex.com>  Mon, 10 Jun 2019 12:33:11 +1200

therion (5.4.3ds1-5) unstable; urgency=medium

  * debian/patches/fix-svg-export-segfault.patch: Fix segmentation fault when
    producing SVG output.  (Closes: #923737)

 -- Olly Betts <olly@survex.com>  Wed, 06 Mar 2019 10:41:20 +1300

therion (5.4.3ds1-4) unstable; urgency=medium

  * debian/tests/therion: Give up trying to compare output images for now -
    the PDF file isn't rebuilt during the package build currently (which ought
    to be addressed, but not right before the freeze), so the timestamps will
    differ, and even a visual compare may not reliably match.  For now, check
    that the therion command produces a non-empty output file without errors.

 -- Olly Betts <olly@survex.com>  Fri, 08 Feb 2019 09:23:36 +1300

therion (5.4.3ds1-3) unstable; urgency=medium

  * debian/tests/control: Specify path to test script.

 -- Olly Betts <olly@survex.com>  Thu, 07 Feb 2019 11:19:33 +1300

therion (5.4.3ds1-2) unstable; urgency=medium

  * debian/tests/control: Need imagemagick to process sample.
  * debian/tests/therion: "set -x" to make debugging failures easier.

 -- Olly Betts <olly@survex.com>  Tue, 05 Feb 2019 08:11:52 +1300

therion (5.4.3ds1-1) unstable; urgency=medium

  * New upstream release
    + debian/copyright: No longer bundles PROJ4 source code.
    + debian/copyright: Update copyright years.
    + debian/patches/: Refresh for changes in upstream release.
  * debian/tests/: Add autopkgtest.

 -- Olly Betts <olly@survex.com>  Mon, 04 Feb 2019 10:58:11 +1300

therion (5.4.2ds1-2) unstable; urgency=medium

  * debian/rules: Enable large file support.
  * debian/control: Specify "Rules-Requires-Root: no"

 -- Olly Betts <olly@survex.com>  Thu, 31 Jan 2019 08:31:44 +1300

=== debian/control ===
Source: therion
Section: science
Priority: optional
Maintainer: Wookey <wookey@debian.org>
Uploaders: Olly Betts <olly@survex.com>
Build-Depends: dpkg (>=1.16.2), debhelper (>= 10), perl (>= 5.5), tcl,
  libvtk6-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev,
  pkg-config, texlive-base, libproj-dev
Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript
Standards-Version: 4.3.0
Homepage: https://therion.speleo.sk/
Rules-Requires-Root: no

Package: therion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl, texlive-base, texlive-metapost, bwidget
Recommends: evince | pdf-viewer, libtk-img, therion-viewer, survex
Suggests: survex-aven, texlive-lang-czechslovak, texlive-lang-cyrillic
Description: Cave surveying - 2D and 3D drawing software
 Therion aids the process of drawing up cave surveys (maps). Drawings are
 done over scans and can be distorted to fit the centreline data. Output is
 in single sheet or atlas style PDF or SVG files. All data is stored in text
 files and a map editor (xtherion) is provided to aid in the creation of the
 files. A wide range of co-ordinate systems is supported.
 .
 Therion can also produce 3D models, generated from walls and
 passage-heights.  Output formats supported are Survex .3d files, VRML, DXF,
 SVG, shapefiles, and the native .lox. Scanned map overlays and relief data
 can be incorporated into models. Therion is compatible with Survex, and
 centreline data can be stored in Survex or Therion form. If survex is
 installed it is used for loop closures. Centreline data and sketches can be
 imported from PocketTopo, allowing full paperless surveying.
 .
 TeX and metapost are used to generate the images. libtk-img is needed to use
 scans in formats other than GIF and PNM (such as PNG and JPEG).
 Survex will be used for loop-closure if installed, but is not required.
 .
 You will need appropriate TeX language packages to process therion files which
 specify those character sets: texlive-lang-czechslovak is needed to process
 the examples, and texlive-lang-cyrillic is also suggested. See README.Debian
 for details.

Package: therion-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, therion
Description: Cave surveying - 3D viewer for therion models
 Therion is cave-survey drawing and modelling software. This package contains
 the 3D model viewer for therion models produced by version 0.4 or later.
 It can also display Survex .3d and Compass .plt files.

Package: therion-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: therion
Depends: ${misc:Depends}
Replaces: therion (<< 0.5.0)
Description: Documentation for Therion Cave surveying software
 Therion is cave-survey drawing and modelling software. This package
 includes the thbook which is the specification for the therion data
 description language. This is not the easiest way to get started;
 there is much more documentation in the Therion wiki:
 https://therion.speleo.sk/wiki/doku.php with introductory guides, FAQs
 and examples. Read those first to get an understanding of how it is
 used.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow future=+lfs

%:
	dh $@

override_dh_auto_build-indep:
	# just build the -doc package
ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	# We need therion itself to build the samples
	$(MAKE) therion
	# create HTML documentation for samples
	$(MAKE) samples
endif
	$(MAKE) thbook

override_dh_auto_clean:
	$(MAKE) clean

override_dh_compress:
	dh_compress -X.pdf -X.th -X.th2 -Xthconfig

override_dh_auto_build-arch:
	# Compile the binaries
	$(MAKE) therion xtherion/xtherion loch/loch
	ln -sf loch.1 man/therion-viewer.7

override_dh_auto_install-arch:
	# we need to clear out large generated files from samples before putting just source files in main package
	$(MAKE) -C samples clean
	mkdir -p debian/tmp/usr/bin debian/tmp/etc
	dh_auto_install -- PREFIX=$(CURDIR)/debian/tmp/usr SYSCONFDIR=$(CURDIR)/debian/tmp/etc
	rm debian/tmp/etc/*.new
	cd loch/locale && for lang in * ; do \
	  install -D "$$lang/loch.mo" "debian/tmp/therion-viewer/usr/share/locale/$$lang/LC_MESSAGES/loch.mo" ; \
	done
	dh_installexamples -ptherion --exclude=.tcl --exclude=Makefile --exclude=thTMPDIR samples therion.ini

## therion 5.4.4ds1

=== Makefile ===
--- 
+++ 
@@ -124,7 +124,9 @@
 
 # proj4 settings
 PROJ_LIBS = $(shell $(CROSS)pkg-config proj --libs)
-CXXJFLAGS = -I$(shell $(CROSS)pkg-config proj --variable=includedir)
+PROJ_MVER = $(shell $(CROSS)pkg-config proj --modversion | sed 's/\..*//')
+CXXJFLAGS = -DPROJ_VER=$(PROJ_MVER) -I$(shell $(CROSS)pkg-config proj --variable=includedir)
+
 
 # compiler settings
 CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS) $(CXXJFLAGS) -std=c++11
@@ -368,5 +370,3 @@
  thobjectsrc.h thlayout.h thdataobject.h thdatabase.h thdb1d.h \
  thobjectid.h thinfnan.h thdataleg.h thobjectname.h thdb3d.h \
  loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
- thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
- thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \

=== loch/Makefile ===
--- 
+++ 
@@ -80,8 +80,8 @@
 # PLATFORM WIN32CROSS
 ##CROSS= i686-w64-mingw32.static-
 ##EXT = .exe
-##VTKVERSION = 8.0
-##VTKPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/include/vtk-8.0
+##VTKVERSION = 8.2
+##VTKPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/include/vtk-$(VTKVERSION)
 ##VTKLIBPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/lib
 ##VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) \
 ##  -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) \

=== samples/Makefile ===
OUTDIR ?= .
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)
else
LOUTDIR = ..
endif


all:
ifneq ($(LOUTDIR),..)
	rm -rf $(LOUTDIR)/samples
	rm -rf $(LOUTDIR)/samples.doc
	cp -rf ../samples $(LOUTDIR)
endif
	tclsh samples.tcl $(LOUTDIR) $(LOUTDIR)/samples
ifneq ($(LOUTDIR),..)
	perl ../makefile.pl mv samples.log $(LOUTDIR)/samples
	rm -f samples.log
endif
    
clean:
	tclsh samples.tcl . clean

=== thchencdata/Makefile ===
all:
	perl generate.pl

=== debian/changelog ===
therion (5.4.4ds1-5ubuntu1) focal; urgency=medium

  * Don't fail because of convert not being able to convert into pdf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Feb 2020 23:40:33 +0100

therion (5.4.4ds1-5) unstable; urgency=medium

  * Fix proj4-style init rules to work (new patch
    fix-proj6-use-proj4-init-rules.patch cherry-picked from upstream git
    master).  (Closes: #946855)

 -- Olly Betts <olly@survex.com>  Wed, 18 Dec 2019 17:10:39 +1300

therion (5.4.4ds1-4) unstable; urgency=medium

  * Allow loch to start if glXCreateContext() fails, as always seems to happen
    in current sid.  Upstream are investigating, but this is only used to
    render off-screen images, so it's better to let loch run than to give up.
    New patch: allow-loch-to-start-without-offscreen-glxcontext.patch
  * debian/control: Declare conformance with policy 4.4.1.

 -- Olly Betts <olly@survex.com>  Sat, 07 Dec 2019 11:55:04 +1300

therion (5.4.4ds1-3) unstable; urgency=medium

  * Fix FTBFS due to python no longer being implicitly pulled in as an
    indirect dependency by applying changes from Steve Langasek to depend on
    python3 and use it to run upstream's set_version.py.  New patch:
    python3-not-python.patch (Closes: #945345)

 -- Olly Betts <olly@survex.com>  Tue, 03 Dec 2019 17:43:25 +1300

therion (5.4.4ds1-2) unstable; urgency=medium

  * debian/control: Add libsqlite3-tcl to Build-Depends - needed with PROJ 6.

 -- Olly Betts <olly@survex.com>  Tue, 17 Sep 2019 16:58:05 +1200

therion (5.4.4ds1-1) unstable; urgency=medium

  * New upstream release
    + Includes patches fix-svg-export-segfault.patch and fix-epsg-esri-cs.patch
      so drop.
  * debian/rules: Drop needless override_dh_auto_clean target - the default
    action does what we want.
  * debian/control: Declare conformance with policy 4.4.0.

 -- Olly Betts <olly@survex.com>  Mon, 08 Jul 2019 11:49:25 +1200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders: Olly Betts <olly@survex.com>
 Build-Depends: dpkg (>=1.16.2), debhelper (>= 10), perl (>= 5.5), tcl,
   libvtk6-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev,
-  pkg-config, texlive-base, libproj-dev
+  pkg-config, texlive-base, libproj-dev, libsqlite3-tcl, python3
 Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: https://therion.speleo.sk/
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,9 @@
 	# We need therion itself to build the samples
 	$(MAKE) therion
 	# create HTML documentation for samples
-	$(MAKE) samples
+	-$(MAKE) samples
 endif
 	$(MAKE) thbook
-
-override_dh_auto_clean:
-	$(MAKE) clean
 
 override_dh_compress:
 	dh_compress -X.pdf -X.th -X.th2 -Xthconfig

=== debian/watch ===
# Run the "uscan" command to check for upstream updates.
version=3
opts="repacksuffix=ds1,dversionmangle=s/\+ds\d*$//" https://therion.speleo.sk/download.php \
 https://github.com/therion/therion/archive/v(.*)\.tar\.gz debian uupdate

## therion 5.5.1ds1

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,7 @@
   thtrans.o thwarpp.o thwarppt.o thwarppme.o thwarp.o thexpshp.o thattr.o thtex.o \
   extern/poly2tri/common/shapes.o extern/poly2tri/sweep/advancing_front.o extern/poly2tri/sweep/sweep.o extern/poly2tri/sweep/cdt.o extern/poly2tri/sweep/sweep_context.o \
   therion.o extern/quickhull/QuickHull.o
+TESTOBJECTS = utest-main.o utest-proj.o
 
 CROSS =
 EXT =
@@ -46,8 +47,8 @@
 
 
 # PLATFORM DEBIAN
-CXX = c++
-CC = gcc
+CXX ?= c++
+CC ?= gcc
 POBJECTS =
 LOCHEXE = loch/loch
 CXXPFLAGS = -DTHLINUX
@@ -58,8 +59,9 @@
 
 
 # PLATFORM WIN32
-##CXX = c++
-##CC = gcc
+##EXT = .exe
+##CXX ?= c++
+##CC ?= gcc
 ##POBJECTS = extern/getopt.o extern/getopt1.o therion.res extern/getline.o
 ##LOCHEXE = loch/loch
 ##CXXPFLAGS = -DTHWIN32
@@ -123,15 +125,19 @@
 # BUILD ENDCONFIG
 
 # proj4 settings
-PROJ_LIBS = $(shell $(CROSS)pkg-config proj --libs)
-PROJ_MVER = $(shell $(CROSS)pkg-config proj --modversion | sed 's/\..*//')
-CXXJFLAGS = -DPROJ_VER=$(PROJ_MVER) -I$(shell $(CROSS)pkg-config proj --variable=includedir)
+PROJ_LIBS ?= $(shell $(CROSS)pkg-config proj --libs)
+PROJ_MVER ?= $(shell $(CROSS)pkg-config proj --modversion | sed 's/\..*//')
+ifeq ($(shell [ "$(PROJ_MVER)" -gt 5 ] && [ "$(THPLATFORM)" = "WIN32" ] && [ -z "$(CROSS)" ]; echo $$?),0)
+  PROJ_LIBS += -lsqlite3
+endif
+CXXJFLAGS ?= -DPROJ_VER=$(PROJ_MVER) -I$(shell $(CROSS)pkg-config proj --variable=includedir)
 
 
 # compiler settings
 CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS) $(CXXJFLAGS) -std=c++11
 CCFLAGS = -DIMG_API_VERSION=1 -Wall $(CCPFLAGS) $(CCBFLAGS)
 OBJECTS = $(addprefix $(OUTDIR)/,$(POBJECTS)) $(addprefix $(OUTDIR)/,$(CMNOBJECTS))
+TESTOBJECTS_P = $(addprefix $(OUTDIR)/,$(TESTOBJECTS))
 
 
 # linker settings
@@ -151,7 +157,7 @@
 $(OUTDIR)/%.o : %.c
 	$(CC) -c $(CCFLAGS) -o $@ $<
 
-all: version outdirs $(OUTDIR)/therion doc xtherion/xtherion $(LOCHEXE)
+all: version outdirs $(OUTDIR)/therion tests doc xtherion/xtherion $(LOCHEXE)
 
 outdirs:
 	mkdir -p $(OUTDIR)/extern/poly2tri/sweep/
@@ -162,17 +168,22 @@
 	mkdir -p $(OUTDIR)/thbook
 
 version:
-	python set_version.py
-
+	python3 set_version.py
+	echo "[PROJ]" > innosetup.ini && echo "version=$(PROJ_MVER)" >> innosetup.ini
 
 $(OUTDIR)/therion: version $(OBJECTS)
-	$(CXX) -Wall -o $(OUTDIR)/therion$(EXT) $(OBJECTS) $(LDFLAGS) $(LIBS)
+	$(CXX) $(CXXFLAGS) -o $(OUTDIR)/therion$(EXT) therion-main.cxx $(OBJECTS) $(LDFLAGS) $(LIBS)
 ifneq ($(THPLATFORM),WIN32)
 	$(MAKE) library
 	$(MAKE) $(OUTDIR)/thlibrary.o
-	$(CXX) -Wall -o $(OUTDIR)/therion$(EXT) $(OBJECTS) $(LDFLAGS) $(LIBS)
+	$(CXX) $(CXXFLAGS) -o $(OUTDIR)/therion$(EXT) therion-main.cxx $(OBJECTS) $(LDFLAGS) $(LIBS)
 endif
 
+tests: version $(OBJECTS) $(TESTOBJECTS_P)
+	$(CXX) $(CXXFLAGS) -o $(OUTDIR)/utest$(EXT) $(OBJECTS) $(TESTOBJECTS_P) $(LDFLAGS) $(LIBS)
+ifneq ($(THPLATFORM),WIN32)
+	$(OUTDIR)/utest$(EXT)
+endif
 
 $(OUTDIR)/therion.res: therion.rc
 	$(CROSS)windres -i therion.rc -J rc -o $(OUTDIR)/therion.res -O coff
@@ -238,12 +249,13 @@
 cleanrest:
 	$(MAKE) -C ./xtherion clean
 	$(MAKE) -C ./loch clean
-	perl makefile.pl rm -q thmpost.cxx thtex.h thlangdata.h thchencdata.cxx thcsdata.h thmpost.h thcsdata.cxx thtex.cxx thsymbolsetlist.h thsymbolsets.cxx thsymbolsets.h thlangdata.cxx thchencdata.h
+	perl makefile.pl rm -q thmpost.cxx thtex.h thlangdata.h thchencdata.cxx thcsdata.h thmpost.h thcsdata.cxx thtex.cxx thsymbolsetlist.h thsymbolsets.cxx thsymbolsets.h thlangdata.cxx thchencdata.h SYMBOLS.txt
 	perl makefile.pl rm -q therion ./xtherion/xtherion ./xtherion/xtherion.tcl therion.exe *~ *.log *.o thchencdata/*~ .xtherion.dat ./xtherion/ver.tcl thversion.h thbook/version.tex
 	perl makefile.pl rm -q xtherion/*~ .xth_thconfig_xth xtherion/screendump thlang/*~
-	perl makefile.pl rm -q extern/*.o extern/*~ extern/poly2tri/common/*.o extern/poly2tri/sweep/*.o samples/*~ samples/*.log
+	perl makefile.pl rm -q extern/*.o extern/*~ extern/quickhull/*.o extern/poly2tri/common/*.o extern/poly2tri/sweep/*.o samples/*~ samples/*.log
 	perl makefile.pl rm -q symbols.html therion.res
 	perl makefile.pl rm -q tri/*.o tri/*~
+	perl makefile.pl rm -q utest
 	perl makefile.pl rm -q tex/*~
 	perl makefile.pl rm -q us.stackdump loch/us.stackdump samples/us.stackdump xtherion/us.stackdump
 	perl makefile.pl rm -q mpost/*~ examples/*~ examples/therion.log
@@ -277,7 +289,7 @@
 	$(MAKE) -C ./thchencdata
 
 thcsdata.h: thcsdata.tcl
-	tclsh thcsdata.tcl
+	tclsh thcsdata.tcl $(CROSS)
 
 update:
 	$(MAKE) -C ./thlang update
@@ -290,39 +302,39 @@
 
 config-debug:
 	perl makeconfig.pl BUILD DEBUG
-	$(MAKE) -C ./loch config-debug
+	cd loch; perl makeconfig.pl BUILD DEBUG
 
 config-release:
 	perl makeconfig.pl BUILD RELEASE
-	$(MAKE) -C ./loch config-release
+	cd loch; perl makeconfig.pl BUILD RELEASE
 
 config-oxygen:
 	perl makeconfig.pl BUILD OXYGEN
-	$(MAKE) -C ./loch config-oxygen
+	cd loch; perl makeconfig.pl BUILD OXYGEN
 
 config-ozone:
 	perl makeconfig.pl BUILD OZONE
-	$(MAKE) -C ./loch config-ozone
+	cd loch; perl makeconfig.pl BUILD OZONE
 
 config-debian:
 	perl makeconfig.pl PLATFORM DEBIAN
-	$(MAKE) -C ./loch config-debian
+	cd loch; perl makeconfig.pl PLATFORM DEBIAN
 
 config-linux:
 	perl makeconfig.pl PLATFORM LINUX
-	$(MAKE) -C ./loch config-linux
+	cd loch; perl makeconfig.pl PLATFORM LINUX
 
 config-win32:
 	perl makeconfig.pl PLATFORM WIN32
-	$(MAKE) -C ./loch config-win32
+	cd loch; perl makeconfig.pl PLATFORM WIN32
 
 config-win32cross:
 	perl makeconfig.pl PLATFORM WIN32CROSS
-	$(MAKE) -C ./loch config-win32cross
+	cd loch; perl makeconfig.pl PLATFORM WIN32CROSS
 
 config-macosx:
 	perl makeconfig.pl PLATFORM MACOSX
-	$(MAKE) -C ./loch config-macosx
+	cd loch; perl makeconfig.pl PLATFORM MACOSX
 
 # external sources
 $(OUTDIR)/extern/lxMath.o: loch/lxMath.h loch/lxMath.cxx
@@ -359,14 +371,3 @@
  thexception.h thexpmap.h thexport.h thlayout.h thsymbolset.h \
  thsymbolsetlist.h thlocale.h thlang.h thlangdata.h thline.h
 $(OUTDIR)/thattr.o: thattr.cxx thattr.h thmbuffer.h thchenc.h thchencdata.h \
- thparse.h thbuffer.h extern/shapefil.h thexception.h therion.h
-$(OUTDIR)/thbezier.o: thbezier.cxx thbezier.h
-$(OUTDIR)/thbuffer.o: thbuffer.cxx thbuffer.h
-$(OUTDIR)/thchenc.o: thchenc.cxx thchenc.h thchencdata.h thparse.h thbuffer.h \
- thmbuffer.h thchencdata.cxx therion.h thexception.h
-$(OUTDIR)/thchencdata.o: thchencdata.cxx
-$(OUTDIR)/thcmdline.o: thcmdline.cxx thcmdline.h therion.h thlogfile.h thbuffer.h \
- thconfig.h thmbuffer.h thinput.h thparse.h thexporter.h thexport.h \
- thobjectsrc.h thlayout.h thdataobject.h thdatabase.h thdb1d.h \
- thobjectid.h thinfnan.h thdataleg.h thobjectname.h thdb3d.h \
- loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \

=== loch/Makefile ===
--- 
+++ 
@@ -19,12 +19,23 @@
 CROSS =
 EXT =
 
+WX_CONFIG = wx-config
+
+VTKSUFFIX = $(shell tclsh ./getvtkver.tcl suffix)
 VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
 VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
 VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
 VTKV6 = $(shell tclsh ./getvtkver.tcl version6)
 ifeq ($(VTKV6),1)
-VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
+VTKLIBS = \
+    -lvtkCommonExecutionModel$(VTKSUFFIX) \
+    -lvtkCommonDataModel$(VTKSUFFIX) \
+    -lvtkCommonCore$(VTKSUFFIX) \
+    -lvtkFiltersCore$(VTKSUFFIX) \
+    -lvtkFiltersHybrid$(VTKSUFFIX) \
+    -lvtkIOLegacy$(VTKSUFFIX) \
+    $(shell pkg-config --libs freetype2) \
+    -lpng -ljpeg
 else
 VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
 endif
@@ -52,19 +63,29 @@
 ##LXPLATFORM = LINUX
 
 # PLATFORM DEBIAN
-CXX = c++
-CC = gcc
-POBJECTS = lxR2P.o
+CXX ?= c++
+CC ?= gcc
 ifeq ($(VTKV6),1)
-VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
 else
 VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
 endif
-CXXPFLAGS = -DLXLINUX -std=c++11 $(shell wx-config --cxxflags) -Wno-deprecated $(shell pkg-config freetype2 --cflags) -I$(VTKPATH)
-CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
+CXXPFLAGS = \
+    -std=c++11 \
+    -Wno-deprecated \
+    $(shell $(WX_CONFIG) --cxxflags) \
+    $(shell pkg-config freetype2 --cflags) \
+    -I$(VTKPATH)
+CCPFLAGS = $(shell $(WX_CONFIG) --cflags)
 LXLIBDIR = linux
 PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
 LXPLATFORM = LINUX
+
+# LXLINUX doesn't work with Arch Linux
+ifneq ($(shell lsb_release -si),Arch)
+  POBJECTS = lxR2P.o
+  CXXPFLAGS += -DLXLINUX
+  CCPFLAGS += -DLXLINUX
+endif
 
 # PLATFORM WIN32
 ##CXX = c++
@@ -139,8 +160,8 @@
 
 
 # compiler settings
-CXXFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CXXPFLAGS) $(CXXBFLAGS)
-CCFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CCPFLAGS) $(CCBFLAGS)
+CXXFLAGS := -Wall -D_GNU_SOURCE -DLOCH $(CXXPFLAGS) $(CXXBFLAGS)
+CCFLAGS := -Wall -D_GNU_SOURCE -DLOCH $(CCPFLAGS) $(CCBFLAGS)
 OBJECTS = $(addprefix $(LOUTDIR)/,$(POBJECTS)) $(addprefix $(LOUTDIR)/,$(CMNOBJECTS))

=== debian/changelog ===
therion (5.5.1ds1-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Don't fail because of convert not being able to convert into pdf

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 25 Oct 2020 01:19:45 -0700

therion (5.5.1ds1-1) unstable; urgency=medium

  * New upstream release
  * Fixes test failure due to proj 7.1 (Closes: #964124)
  * Show deprecation warnings
  * Use system catch2

 -- Wookey <wookey@debian.org>  Fri, 03 Jul 2020 22:08:06 +0100

therion (5.5.0ds1-1) unstable; urgency=medium

  * New upstream release.
  * Use system version of shapelib (libshp2)

 -- Wookey <wookey@debian.org>  Tue, 30 Jun 2020 14:51:23 +0000

therion (5.4.4ds1-5ubuntu2) groovy; urgency=medium

  * No-change rebuild against libproj19

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 06 May 2020 19:56:55 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: therion
 Section: science
 Priority: optional
-Maintainer: Wookey <wookey@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Wookey <wookey@debian.org>
 Uploaders: Olly Betts <olly@survex.com>
 Build-Depends: dpkg (>=1.16.2), debhelper (>= 10), perl (>= 5.5), tcl,
   libvtk6-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev,
-  pkg-config, texlive-base, libproj-dev, libsqlite3-tcl, python3
+  pkg-config, texlive-base, libproj-dev, libsqlite3-tcl, python3,
+  libshp-dev, catch2
 Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript
 Standards-Version: 4.4.1
 Homepage: https://therion.speleo.sk/

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,8 @@
 	mkdir -p debian/tmp/usr/bin debian/tmp/etc
 	dh_auto_install -- PREFIX=$(CURDIR)/debian/tmp/usr SYSCONFDIR=$(CURDIR)/debian/tmp/etc
 	rm debian/tmp/etc/*.new
-	cd loch/locale && for lang in * ; do \
-	  install -D "$$lang/loch.mo" "debian/tmp/therion-viewer/usr/share/locale/$$lang/LC_MESSAGES/loch.mo" ; \
-	done
+	# upstream has cz locale when it should be cs
+	(cd loch/locale && (mv cz cs | true) && for lang in * ; do \
+	  install -D -m 644 "$$lang/loch.mo" "$(CURDIR)/debian/therion-viewer/usr/share/locale/$$lang/LC_MESSAGES/loch.mo" ; \
+	done && mv cs cz)
 	dh_installexamples -ptherion --exclude=.tcl --exclude=Makefile --exclude=thTMPDIR samples therion.ini
